/*
 * 盟主管理
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class LeadersController : BaseController
    {
        public LeadersController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 盟主管理列表

        /// <summary>
        /// 根据条件查询盟主管理列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(Leaders data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询盟主管理列表

        /// <summary>
        /// 盟主管理列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(Leaders data, string UserIdMakerCode, string LeaderLevelSelect, string LeaderStatusSelect, string LastBuyDateData, string ExpiredDateData, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //盟主等级
            if (!string.IsNullOrEmpty(LeaderLevelSelect))
            {
                condition += " and LeaderLevel=" + LeaderLevelSelect;
            }
            //状态
            if (!string.IsNullOrEmpty(LeaderStatusSelect))
            {
                var time = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
                if (LeaderStatusSelect == "0")
                {
                    condition += " and ExpiredDate>'" + time + "'";
                }
                else
                {
                    condition += " and ExpiredDate<='" + time + "'";
                }
            }
            //首次购买时间
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }
            //最后购买时间
            if (!string.IsNullOrEmpty(LastBuyDateData))
            {
                string[] datelist = LastBuyDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and LastBuyDate>='" + start + " 00:00:00' and LastBuyDate<='" + end + " 23:59:59'";
            }
            //盟主到期时间
            if (!string.IsNullOrEmpty(ExpiredDateData))
            {
                string[] datelist = ExpiredDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and ExpiredDate>='" + start + " 00:00:00' and ExpiredDate<='" + end + " 23:59:59'";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("Leaders", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();

                var userAccount = db.UserAccount.FirstOrDefault(m => m.Id == UserId) ?? new UserAccount();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["LeaderReserve"] = userAccount.LeaderReserve;
                dic["LeaderBalanceAmount"] = userAccount.LeaderBalanceAmount;
                var StatMonth = DateTime.Now.ToString("yyyy-MM");
                var leaderReconRecord = db.LeaderReconRecord.FirstOrDefault(m => m.UserId == UserId && m.StatMonth == StatMonth) ?? new LeaderReconRecord();
                dic["LastMonthReserve"] = leaderReconRecord.ReserveAmount;
                dic["LastMonthBalanceAmount"] = leaderReconRecord.BalanceAmount;

                var ExpiredDate = DateTime.Parse(dic["ExpiredDate"].ToString());
                if (ExpiredDate > DateTime.Now)
                {
                    dic["LeaderStatus"] = "未过期";
                }
                else
                {
                    dic["LeaderStatus"] = "已过期";
                }
                dic.Remove("UserId");
                //盟主等级
                int LeaderLevel = int.Parse(dic["LeaderLevel"].ToString());
                if (LeaderLevel == 1) dic["LeaderLevel"] = "小盟主";
                if (LeaderLevel == 2) dic["LeaderLevel"] = "大盟主";
                if (LeaderLevel == 0) dic["LeaderLevel"] = "";

            }
            return Json(obj);
        }

        #endregion

        #region 增加盟主管理

        /// <summary>
        /// 增加或修改盟主管理信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加盟主管理

        /// <summary>
        /// 增加或修改盟主管理信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(Leaders data, string MakerCode)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            var userForMakerCode = db.UserForMakerCode.FirstOrDefault(m => m.MakerCode == MakerCode) ?? new UserForMakerCode();
            if (userForMakerCode.UserId > 0)
            {
                var user = db.Users.FirstOrDefault(m => m.Id == userForMakerCode.UserId) ?? new Users();
                if (user.Id > 0)
                {
                    user.LeaderLevel = data.LeaderLevel;
                    Fields.Add("UserId", userForMakerCode.UserId); //创客
                    Fields.Add("LeaderLevel", data.LeaderLevel); //盟主等级
                    Fields.Add("SeoKeyword", data.SeoKeyword);//附件
                    int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("Leaders", Fields, 0);
                    AddSysLog(data.Id.ToString(), "Leaders", "add");
                    db.SaveChanges();
                }
            }

            return "success";
        }

        #endregion

        #region 修改盟主管理

        /// <summary>
        /// 增加或修改盟主管理信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            Leaders editData = db.Leaders.FirstOrDefault(m => m.Id == Id) ?? new Leaders();
            Users editDatas = db.Users.FirstOrDefault(m => m.Id == editData.UserId) ?? new Users();
            ViewBag.data = editData;
            ViewBag.datas = editDatas;
            return View();
        }

        #endregion

        #region 修改盟主管理

        /// <summary>
        /// 增加或修改盟主管理信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(Leaders data, string MakerCode)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            var userForMakerCode = db.UserForMakerCode.FirstOrDefault(m => m.MakerCode == MakerCode) ?? new UserForMakerCode();
            if (userForMakerCode.UserId > 0)
            {
                var user = db.Users.FirstOrDefault(m => m.Id == userForMakerCode.UserId) ?? new Users();
                if (user.Id > 0)
                {
                    user.LeaderLevel = data.LeaderLevel;
                    Fields.Add("UserId", userForMakerCode.UserId); //创客
                    Fields.Add("LeaderLevel", data.LeaderLevel); //盟主等级
                    Fields.Add("SeoKeyword", data.SeoKeyword);
                    new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Leaders", Fields, data.Id);
                    var leader = db.Leaders.FirstOrDefault(m => m.Id == data.Id) ?? new Leaders();
                    if (leader.Id > 0)
                    {
                        leader.CreateDate = leader.CreateDate;
                    }
                    AddSysLog(data.Id.ToString(), "Leaders", "update");
                    db.SaveChanges();
                }
            }

            return "success";
        }

        #endregion


        #region 修改盟主金额

        public IActionResult ChangeLeaderAmount(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            Leaders leaders = db.Leaders.FirstOrDefault(m => m.Id == Id) ?? new Leaders();
            Users editData = db.Users.FirstOrDefault(m => m.Id == leaders.UserId) ?? new Users();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改盟主金额

        [HttpPost]
        public string ChangeLeaderAmount(Leaders data, string ChangeAmount, int AmountType, string Note, int Kind)
        {
            int UserId = data.Id;
            var Amount = Convert.ToDecimal(ChangeAmount);
            UserAccount account = db.UserAccount.FirstOrDefault(m => m.Id == UserId);
            if (account == null)
            {
                account = db.UserAccount.Add(new UserAccount()
                {
                    Id = UserId,
                    CreateDate = DateTime.Now,
                    CreateMan = SysUserName + "-" + SysRealName,
                    UserId = UserId,
                }).Entity;
                db.SaveChanges();
            }
            //盟主储蓄金
            if (AmountType == 1)
            {
                if ((Kind == 1 || Kind == 3) && Amount > account.LeaderReserve)
                {
                    return "盟主储蓄金不足";
                }
                decimal BeforeLeaderReserve = account.LeaderReserve; //变更前盟主储蓄金
                decimal BeforeLeaderBalanceAmount = account.LeaderBalanceAmount; //变更前盟主可提现余额
                int ChangeType = 0;
                if (Kind == 1 && Amount <= account.LeaderReserve)
                {
                    account.LeaderReserve -= Amount;
                    account.TotalProfit += Amount;
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统冻结(盟主储蓄金)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                else if (Kind == 1 && Amount > account.LeaderReserve)
                {
                    return "冻结金额大于盟主储蓄金";
                }
                else if (Kind == 2 && Amount <= account.TotalProfit)
                {
                    account.LeaderReserve += Amount;
                    account.TotalProfit -= Amount;
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统解冻(盟主储蓄金)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                else if (Kind == 2 && Amount > account.TotalProfit)
                {
                    return "解冻金额大于冻结金额";
                }
                else if (Kind == 3 && Amount <= account.LeaderReserve)
                {
                    account.LeaderReserve -= Amount;
                    ChangeType = 2;
                    decimal AfterLeaderReserve = account.LeaderReserve; //变更后盟主储蓄金
                    decimal AfterLeaderBalanceAmount = account.LeaderBalanceAmount; //变更后盟主可提现余额
                    var query = db.LeaderReserveRecord.Add(new LeaderReserveRecord()
                    {
                        CreateDate = DateTime.Now, //创建时间
                        SeoDescription = Note,//备注
                        Sort = 11, //类型
                        //11：盟主储蓄金增减单(兑换机具券 机具券兑换 系统增加(盟主储蓄金) 系统扣减(盟主储蓄金) 储备金购买)
                        // 示例：+/-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 12：可提现余额增减单(系统增加(可提现余额) 系统扣减(可提现余额))
                        // 示例：+/-金额
                        // 	可提现余额：剩余可提现余额
                        // 13：盟主储蓄金减少可提现余额增加(推荐大/小盟主 商城购机 购机奖励)
                        // 示例：-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 	可提现余额：+金额
                        UserId = UserId, //创客
                        Remark = "系统扣减(盟主储蓄金)",
                        ChangeType = ChangeType,
                        BeforeAmt = BeforeLeaderReserve,
                        AfterAmt = AfterLeaderReserve,
                        ChangeAmt = Amount,
                        TradeDate = DateTime.Now.ToString("yyyyMMdd"),
                        TradeMonth = DateTime.Now.ToString("yyyyMM"),
                    }).Entity;
                    db.SaveChanges();
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统扣减(盟主储蓄金)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                else if (Kind == 3 && Amount > account.LeaderReserve)
                {
                    return "扣减金额大于盟主储蓄金";
                }
                else if (Kind == 4)
                {
                    account.LeaderReserve += Amount;
                    ChangeType = 1;
                    decimal AfterLeaderReserve = account.LeaderReserve; //变更后总金额
                    decimal AfterLeaderBalanceAmount = account.LeaderBalanceAmount; //变更后冻结金额
                    var query = db.LeaderReserveRecord.Add(new LeaderReserveRecord()
                    {
                        CreateDate = DateTime.Now, //创建时间
                        SeoDescription = Note,//备注
                        Sort = 11, //类型
                        //11：盟主储蓄金增减单(兑换机具券 机具券兑换 系统增加(盟主储蓄金) 系统扣减(盟主储蓄金) 储备金购买)
                        // 示例：+/-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 12：可提现余额增减单(系统增加(可提现余额) 系统扣减(可提现余额))
                        // 示例：+/-金额
                        // 	可提现余额：剩余可提现余额
                        // 13：盟主储蓄金减少可提现余额增加(推荐大/小盟主 商城购机 购机奖励)
                        // 示例：-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 	可提现余额：+金额
                        UserId = UserId, //创客
                        Remark = "系统增加(盟主储蓄金)",
                        ChangeType = ChangeType,
                        BeforeAmt = BeforeLeaderReserve,
                        AfterAmt = AfterLeaderReserve,
                        ChangeAmt = Amount,
                        TradeDate = DateTime.Now.ToString("yyyyMMdd"),
                        TradeMonth = DateTime.Now.ToString("yyyyMM"),
                    }).Entity;
                    db.SaveChanges();
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统增加(盟主储蓄金)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                AddSysLog(data.Id.ToString(), "Leaders", "ChangeLeaderAmount");
                db.SaveChanges();
            }
            //盟主可提现余额
            if (AmountType == 2)
            {
                if ((Kind == 1 || Kind == 3) && Amount > account.LeaderBalanceAmount)
                {
                    return "盟主可提现余额不足";
                }
                decimal BeforeLeaderReserve = account.LeaderReserve; //变更前盟主储蓄金
                decimal BeforeLeaderBalanceAmount = account.LeaderBalanceAmount; //变更前盟主可提现余额
                int ChangeType = 0;
                if (Kind == 1 && Amount <= account.LeaderReserve)
                {
                    account.LeaderBalanceAmount -= Amount;
                    account.TotalServiceProfit += Amount;
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统冻结(盟主可提现余额)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                else if (Kind == 1 && Amount > account.LeaderBalanceAmount)
                {
                    return "冻结金额大于盟主可提现余额";
                }
                else if (Kind == 2 && Amount <= account.TotalServiceProfit)
                {
                    account.LeaderBalanceAmount += Amount;
                    account.TotalServiceProfit -= Amount;
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统解冻(盟主可提现余额)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                else if (Kind == 2 && Amount > account.TotalServiceProfit)
                {
                    return "解冻金额大于冻结金额";
                }
                else if (Kind == 3 && Amount <= account.LeaderBalanceAmount)
                {
                    account.LeaderBalanceAmount -= Amount;
                    ChangeType = 2;
                    decimal AfterLeaderReserve = account.LeaderReserve; //变更后总金额
                    decimal AfterLeaderBalanceAmount = account.LeaderBalanceAmount; //变更后冻结金额
                    var query = db.LeaderReserveRecord.Add(new LeaderReserveRecord()
                    {
                        CreateDate = DateTime.Now, //创建时间
                        SeoDescription = Note,//备注
                        Sort = 12, //类型
                        //11：盟主储蓄金增减单(兑换机具券 机具券兑换 系统增加(盟主储蓄金) 系统扣减(盟主储蓄金) 储备金购买)
                        // 示例：+/-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 12：可提现余额增减单(系统增加(可提现余额) 系统扣减(可提现余额))
                        // 示例：+/-金额
                        // 	可提现余额：剩余可提现余额
                        // 13：盟主储蓄金减少可提现余额增加(推荐大/小盟主 商城购机 购机奖励)
                        // 示例：-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 	可提现余额：+金额
                        UserId = UserId, //创客
                        Remark = "系统扣减(盟主可提现余额)",
                        ChangeType = ChangeType,
                        BeforeAmt = BeforeLeaderBalanceAmount,
                        AfterAmt = AfterLeaderBalanceAmount,
                        ChangeAmt = Amount,
                        TradeDate = DateTime.Now.ToString("yyyyMMdd"),
                        TradeMonth = DateTime.Now.ToString("yyyyMM"),
                    }).Entity;
                    db.SaveChanges();
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统扣减(盟主可提现余额)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                else if (Kind == 3 && Amount > account.LeaderBalanceAmount)
                {
                    return "扣减金额大于盟主可提现余额";
                }
                else if (Kind == 4)
                {
                    account.LeaderBalanceAmount += Amount;
                    ChangeType = 1;
                    decimal AfterLeaderReserve = account.LeaderReserve; //变更后总金额
                    decimal AfterLeaderBalanceAmount = account.LeaderBalanceAmount; //变更后冻结金额
                    var query = db.LeaderReserveRecord.Add(new LeaderReserveRecord()
                    {
                        CreateDate = DateTime.Now, //创建时间
                        SeoDescription = Note,//备注
                        Sort = 12, //类型
                        //11：盟主储蓄金增减单(兑换机具券 机具券兑换 系统增加(盟主储蓄金) 系统扣减(盟主储蓄金) 储备金购买)
                        // 示例：+/-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 12：可提现余额增减单(系统增加(可提现余额) 系统扣减(可提现余额))
                        // 示例：+/-金额
                        // 	可提现余额：剩余可提现余额
                        // 13：盟主储蓄金减少可提现余额增加(推荐大/小盟主 商城购机 购机奖励)
                        // 示例：-金额
                        // 	盟主储蓄金：剩余盟主储蓄金
                        // 	可提现余额：+金额
                        UserId = UserId, //创客
                        Remark = "系统增加(盟主可提现余额)",
                        ChangeType = ChangeType,
                        BeforeAmt = BeforeLeaderBalanceAmount,
                        AfterAmt = AfterLeaderBalanceAmount,
                        ChangeAmt = Amount,
                        TradeDate = DateTime.Now.ToString("yyyyMMdd"),
                        TradeMonth = DateTime.Now.ToString("yyyyMM"),
                    }).Entity;
                    db.SaveChanges();
                    string text = string.Format("修改盟主金额，操作人: '" + SysUserName + "_" + SysRealName + "'，操作类型: '系统增加(盟主可提现余额)'，Time'" + DateTime.Now + "'");
                    function.WriteLog(text, "ChangeLeaderAmount");//修改盟主金额
                }
                AddSysLog(data.Id.ToString(), "Leaders", "ChangeLeaderAmount");
                db.SaveChanges();
            }
            return "success";
        }

        #endregion


        #region 删除盟主管理信息

        /// <summary>
        /// 删除盟主管理信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "Leaders", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Leaders", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "Leaders", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Leaders", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "Leaders", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Leaders", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("Leaders", Sort, Id);

            AddSysLog(Id.ToString(), "Leaders", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.Leaders.Add(new Leaders()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "Leaders", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(Leaders data, string UserIdMakerCode, string LeaderLevelSelect, string LeaderStatusSelect, string LastBuyDateData, string ExpiredDateData, string CreateDateData)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //盟主等级
            if (!string.IsNullOrEmpty(LeaderLevelSelect))
            {
                condition += " and LeaderLevel=" + LeaderLevelSelect;
            }
            //状态
            if (!string.IsNullOrEmpty(LeaderStatusSelect))
            {
                var time = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
                if (LeaderStatusSelect == "0")
                {
                    condition += " and ExpiredDate>'" + time + "'";
                }
                else
                {
                    condition += " and ExpiredDate<='" + time + "'";
                }
            }
            //首次购买时间
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }
            //最后购买时间
            if (!string.IsNullOrEmpty(LastBuyDateData))
            {
                string[] datelist = LastBuyDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and LastBuyDate>='" + start + " 00:00:00' and LastBuyDate<='" + end + " 23:59:59'";
            }
            //盟主到期时间
            if (!string.IsNullOrEmpty(ExpiredDateData))
            {
                string[] datelist = ExpiredDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and ExpiredDate>='" + start + " 00:00:00' and ExpiredDate<='" + end + " 23:59:59'";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("Leaders", Fields, "Id desc", "0", 1, 20000, condition, "UserId,LeaderLevel,CreateDate", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //盟主等级
                int LeaderLevel = int.Parse(dic["LeaderLevel"].ToString());
                if (LeaderLevel == 1) dic["LeaderLevel"] = "小盟主";
                if (LeaderLevel == 2) dic["LeaderLevel"] = "大盟主";
                if (LeaderLevel == 0) dic["LeaderLevel"] = "";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客创客编号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("LeaderLevel", "盟主等级");
            ReturnFields.Add("CreateDate", "创建时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "Leaders", "ExportExcel");
            return Json(result);
        }

        #endregion


        #region 快捷导出Excel
        public IActionResult QuickExportExcel(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        [HttpPost]
        public string QuickExportExcelDo(string UserIdMakerCode, string LeaderLevelSelect, string LeaderStatusSelect, string LastBuyDateData, string ExpiredDateData, string CreateDateData)
        {
            var lastMonth = DateTime.Now.ToString("yyyy-MM");
            string condition = " and a.Status>-1 and d.StatMonth='" + lastMonth + "'";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and a.UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //盟主等级
            if (!string.IsNullOrEmpty(LeaderLevelSelect))
            {
                condition += " and a.LeaderLevel=" + LeaderLevelSelect;
            }
            //状态
            if (!string.IsNullOrEmpty(LeaderStatusSelect))
            {
                var time = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
                if (LeaderStatusSelect == "0")
                {
                    condition += " and a.ExpiredDate>'" + time + "'";
                }
                else
                {
                    condition += " and a.ExpiredDate<='" + time + "'";
                }
            }
            //首次购买时间
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and a.CreateDate>='" + start + " 00:00:00' and a.CreateDate<='" + end + " 23:59:59'";
            }
            //最后购买时间
            if (!string.IsNullOrEmpty(LastBuyDateData))
            {
                string[] datelist = LastBuyDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and a.LastBuyDate>='" + start + " 00:00:00' and a.LastBuyDate<='" + end + " 23:59:59'";
            }
            //盟主到期时间
            if (!string.IsNullOrEmpty(ExpiredDateData))
            {
                string[] datelist = ExpiredDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and a.ExpiredDate>='" + start + " 00:00:00' and a.ExpiredDate<='" + end + " 23:59:59'";
            }
            var Sql = "SELECT c.MakerCode '创客编号',c.RealName '真实姓名',DATE_FORMAT(a.CreateDate,'%Y-%m-%d %H:%i:%s') '首次购买时间',DATE_FORMAT(a.LastBuyDate,'%Y-%m-%d %H:%i:%s') '最后购买时间',DATE_FORMAT(a.ExpiredDate,'%Y-%m-%d %H:%i:%s') '盟主到期时间',(CASE WHEN a.ExpiredDate>NOW() THEN '未过期' ELSE '已过期' end) '状态',(CASE WHEN a.LeaderLevel=1 THEN '小盟主' WHEN a.LeaderLevel=2 THEN '大盟主' ELSE '' end) '盟主等级',b.LeaderReserve '盟主储蓄金',b.LeaderBalanceAmount '盟主可提现余额',d.ReserveAmount '上月盟主储蓄金',d.BalanceAmount '上月可提现余额' FROM Leaders a LEFT JOIN UserAccount b ON a.Id=b.Id LEFT JOIN Users c ON a.Id=c.Id LEFT JOIN LeaderReconRecord d ON a.Id=d.UserId WHERE 1=1" + condition;
            var sysAdmin = bsdb.SysAdmin.FirstOrDefault(m => m.AdminName == SysUserName && m.Status > -1);
            var FileName = "盟主记录" + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            string SendData = "{\"Operater\":\"" + sysAdmin.Id + "\",\"SqlString\":\"" + Sql + "\",\"FileName\":\"" + FileName + "\",\"MaxCount\":\"0\"}";
            RedisDbconn.Instance.AddList("ExportQueue", SendData);
            return "success";
        }
        #endregion

    }
}
